// Программа, управляющая работой сигнализатора утечки горючих газов и задымления на основе MQ2

int MQ2_a = 0;    // аналоговый вывод датчика газа подключается к 0-му аналоговому порту
int MQ2_d = 15;    // цифровой вывод датчика газа подключается к 15-му цифровому порту
int A = 0;        // переменная для хранения значения входного напряжения на аналоговом выходе датчика
int D;        // переменная для хранения значения на цифровом выходе датчика

int T;            //температура

int BA = 10;      //порт ЗП-1

int i; // счетчик циклов

//массив с уровнями тревоги
int Alert[7]={100,200,300,400,500,600,700};


//функция проигрывания звука
void sound()
{
  for (i=0; i<=5; i++)
  {
    tone(BA,1000);
    delay(100);
    tone(BA,2000);
    delay(100);
    tone(BA,3000);
    delay(100);
    tone(BA,2000);
    delay(100);
    tone(BA,1000);
    delay(100);
  }
}

void setup() 
{ 
  Serial.begin(1200); //Передача данных через последовательный порт для отладки
  
  // порты светодиодов индикации уровня опасности
  pinMode(9, OUTPUT);
  pinMode(8, OUTPUT);
  pinMode(7, OUTPUT);
  pinMode(6, OUTPUT);
  pinMode(5, OUTPUT);
  pinMode(4, OUTPUT);
  pinMode(3, OUTPUT);
  
  // индикатор питания
  pinMode(2, OUTPUT);
  
  // динамик
  pinMode(BA, OUTPUT);
  
  // цифровой вывод датчика газа подключается к 1-му аналоговому порту
  pinMode(MQ2_d, INPUT);
  
  // управление мощными светодиодами
  pinMode(11, OUTPUT);
 
  // индикация питания
  digitalWrite(2, HIGH);
   
  // проверка светодиодов 
  digitalWrite(9, HIGH);
  digitalWrite(8, HIGH);
  digitalWrite(7, HIGH);
  digitalWrite(6, HIGH);
  digitalWrite(5, HIGH);
  digitalWrite(4, HIGH);
  digitalWrite(3, HIGH);
  
  // проверка ярких светодиодов
  digitalWrite(11, HIGH);
  
  // проверка динамика
  sound();
    
  noTone(BA); //выключение звука
  
  // выключение светодиодов
  digitalWrite(9, LOW);
  digitalWrite(8, LOW);
  digitalWrite(7, LOW);
  digitalWrite(6, LOW);
  digitalWrite(5, LOW);
  digitalWrite(4, LOW);
  digitalWrite(3, LOW);
  digitalWrite(2, LOW);
  
  // выключение ярких светодиодов
  digitalWrite(11, LOW);
  
 }

void loop() 
{ 
  // индикация питания
  digitalWrite(2, LOW);
  digitalWrite(2, HIGH);
  
  noTone(BA); //выключение звука
  
  // выключение светодиодов
  digitalWrite(9, LOW);
  digitalWrite(8, LOW);
  digitalWrite(7, LOW);
  digitalWrite(6, LOW);
  digitalWrite(5, LOW);
  digitalWrite(4, LOW);
  digitalWrite(3, LOW);
 
  
  // выключение ярких светодиодов
  digitalWrite(11, LOW);
    
  
  T = analogRead(4); // Измерение температуры
  //сигнал тревоги по информации от датчика температуры
  if (T > 750)
    {
      sound();
      digitalWrite(11, HIGH);
    }
  
  // Передача данных о температуре через последовательный порт при отладке  
  Serial.print("T=");
  Serial.println(T);
  
  
  D = digitalRead(MQ2_d);   // считываем значение с цифрового выхода MQ2
  //сигнал тревоги по цифровому каналу датчика MQ2
  if (D=!HIGH)
  {
    sound();
    digitalWrite(3, HIGH);
    digitalWrite(11, HIGH);
  }
  
  // Передача данных о состоянии цифрового выхода датчика при отладке
  Serial.print("MQ2_d=");
  Serial.println(D);
  
  A = analogRead(MQ2_a);    // считываем значение с аналогового выхода MQ2
  
  // Передача данных о состоянии аналогового выхода датчика при отладке      
  Serial.print("MQ2_a=");
  Serial.println(A);
  
  //сигнал тревоги по аналоговому каналу датчика MQ2
    if (A > Alert[0])
    {
      digitalWrite(9, LOW);
      digitalWrite(8, LOW);
      digitalWrite(7, LOW);
      digitalWrite(6, LOW);
      digitalWrite(5, LOW);
      digitalWrite(4, LOW);
      digitalWrite(3, HIGH);
    }
    if (A > Alert[1])
    {
      digitalWrite(9, LOW);
      digitalWrite(8, LOW);
      digitalWrite(7, LOW);
      digitalWrite(6, LOW);
      digitalWrite(5, LOW);
      digitalWrite(4, HIGH);
      digitalWrite(3, HIGH);
    }
    if (A > Alert[2])
    {
      digitalWrite(9, LOW);
      digitalWrite(8, LOW);
      digitalWrite(7, LOW);
      digitalWrite(6, LOW);
      digitalWrite(5, HIGH);
      digitalWrite(4, HIGH);
      digitalWrite(3, HIGH);
    }
    if (A > Alert[3])
    {
      digitalWrite(9, LOW);
      digitalWrite(8, LOW);
      digitalWrite(7, LOW);
      digitalWrite(6, HIGH);
      digitalWrite(5, HIGH);
      digitalWrite(4, HIGH);
      digitalWrite(3, HIGH);
      //звуковой сигнал
      sound();
      //включение ярких светодиодов
      digitalWrite(11, HIGH);
    }
    if (A > Alert[4])
    {
      digitalWrite(9, LOW);
      digitalWrite(8, LOW);
      digitalWrite(7, HIGH);
      digitalWrite(6, HIGH);
      digitalWrite(5, HIGH);
      digitalWrite(4, HIGH);
      digitalWrite(3, HIGH);
      //звуковой сигнал
      sound();
      //включение ярких светодиодов
      digitalWrite(11, HIGH);
    }
    if (A > Alert[5])
    {
      digitalWrite(9, LOW);
      digitalWrite(8, HIGH);
      digitalWrite(7, HIGH);
      digitalWrite(6, HIGH);
      digitalWrite(5, HIGH);
      digitalWrite(4, HIGH);
      digitalWrite(3, HIGH);
      //звуковой сигнал
      sound();
      //включение ярких светодиодов
      digitalWrite(11, HIGH);
    }
    if (A > Alert[6])
    {
      digitalWrite(9, HIGH);
      digitalWrite(8, HIGH);
      digitalWrite(7, HIGH);
      digitalWrite(6, HIGH);
      digitalWrite(5, HIGH);
      digitalWrite(4, HIGH);
      digitalWrite(3, HIGH);
      //звуковой сигнал
      sound();
      //включение ярких светодиодов
      digitalWrite(11, HIGH);
    }
    delay(100);
  
  
}
